﻿/*

C#-Programm: Tontraeger_Hierarchie (c)2015 by www.gossmann.at
C#-Übung: T2H3 – Tontraeger
V0.9 - last mod: 060115

Aufgabenstellung (Zweck: Klassen u. Methodendeklarationen und -aufrufe lernen):
-------------------------------------------------------------------------------

T2H3 – Tonträger
Entwerfen und implementieren Sie eine Klassenhierarchie zur Darstellung von Tonträgern und zwar
CD, LP Schallplatte und Single Schallplatte. Die nachfolgende Tabelle zeigt, welche Eigenschaften bei
welchen Tonträgern vorhanden sind.
Genre Interpret Albumtitel Erscheinungsjahr Liste der
Songs
rpm
CD √ √ √ √ √
LP √ √ √ √ √ √
Single √ √ √ √ √ √
Pro Tonträger werden maximal 20 Songs gespeichert. Für jeden Song wird der Titel und die Laufzeit
in Sekunden gespeichert. Beachten Sie, dass LP Schallplatte und Single Schallplatte sich nur durch die
Umdrehungsgeschwindigkeit (33 rpm und 45 rpm) unterscheiden. Für jeden Tonträger sollen
Methoden zur Berechnung der gesamten Abspielzeit und der durchschnittlichen Songdauer, sowie
zur Ausgabe aller Details des Tonträgers auf Konsole implementiert werden. Überlegen Sie welche
Methoden und Instanzvariablen auf welcher Ebene der Klassenhierarchie implementiert werden
sollten und ob Methoden überlagert werden können.
 
*/
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace t2h3
{
    class Tontraeger_Hierarchie_main
    {
        static void Main(string[] args)
        {

            Console.Clear(); // Platz da am Konsolen-Schirm -> Wisch- und Weg machen...

            // dem User kurze Infos zum Programm und einen Erklärungsteil präsentieren:

            Console.WriteLine ("Tontraeger_Hierarchie V0.9a - (c) by www.gossmann.at" );
            Console.WriteLine ("jan-2015\n"                                           );
            Console.WriteLine ("Tontraeger_Hierarchie implementiert Tonträger-Klassen");
            Console.WriteLine ("und ruft jeweils ein Beispiel exemplarisch auf (CD,"  );            
            Console.WriteLine ("LP, Single)\n"                                        );            

            // *********************************************************************
            // eine CD anlegen und alles Mögliche initialisieren und danach ausgeben
            // *********************************************************************
            
            CD OBJ_CD = new CD("mixed Punk & Poetry", "Ali Muffa", "Ali Muffa in Concert", 2010);
            
            // darin 20 Ali-Muffa-Songs eintragen

            OBJ_CD.song_aufnehmen ("Intro"                               , 120);
            OBJ_CD.song_aufnehmen ("We play it better"                   ,  90);
            OBJ_CD.song_aufnehmen ("Forestall"                           , 182);
            OBJ_CD.song_aufnehmen ("I wü a Bier, des kapier oder krepier", 242);
            OBJ_CD.song_aufnehmen ("Das schlechteste Lied aller Zeiten"  , 132);
            OBJ_CD.song_aufnehmen ("Melvins or Elvis"                    , 193);
            OBJ_CD.song_aufnehmen ("Das Echo der Heimat"                 , 128);
            OBJ_CD.song_aufnehmen ("Der Jäger"                           , 203);
            OBJ_CD.song_aufnehmen ("Das oh Scheiße-Lied / James Hetfield",  57);
            OBJ_CD.song_aufnehmen ("Beidl Joe / Podravka-Lied"           , 178);
            OBJ_CD.song_aufnehmen ("Der Papst"                           , 128);
            OBJ_CD.song_aufnehmen ("Krumpeck Baua - Goschnhaua"          , 165);
            OBJ_CD.song_aufnehmen ("Ihr, die ihr den eurigen"            , 162);
            OBJ_CD.song_aufnehmen ("De wos stazionian"                   , 118);
            OBJ_CD.song_aufnehmen ("Das Neptokarlied"                    , 137);
            OBJ_CD.song_aufnehmen ("Der Nihilist"                        , 144);
            OBJ_CD.song_aufnehmen ("Hotel Royale / Dinosaurier-Lied"     , 137);
            OBJ_CD.song_aufnehmen ("Ali Muffa und die 40 Schuftla"       , 129);
            OBJ_CD.song_aufnehmen ("Undercover Agency"                   , 152);
            OBJ_CD.song_aufnehmen ("Schnepfnick"                         , 191);
            
            // eine Nr. 21 würde nicht mehr gehen, da max. 20 Songs -> if-Konstrukt könnte um alle Songs gelegt werden...

            if (OBJ_CD.song_aufnehmen("Sometimes", 204) == false) // Tonträger-Methode meldete Fehler u. fehlerhaften Song
               {
               /* hier könnten weitere Schritte erfolgen - z.B. nachfragen, ob Tonträger anders befüllt werden soll, Löschroutinen einbauen für Songs, Programmabbruch, etc... */
               Console.WriteLine("Hier ist nur ein Teststring, der meldet,\ndass die Tonträger-Methode korrekt false zurückgeliefert hat für Song# 21...\n");
               }
            
            // Ausgabe der Daten zum Tonträger:

            Console.WriteLine ("************************************************************************\n"                                        );
            Console.WriteLine ("Bein Tonträger handelt es sich um folenden Typ: " + OBJ_CD.GetType().Name.ToString() + " mit folgenden Details:\n");

            OBJ_CD.Drucken(); // sämtliche Infos vom Objekt ausgeben (Daten, Tracklist, Gesamtspieldauer, Durchschnittssongdauer)
            
            Console.WriteLine(""); // Übersichtsleerzeile

            // *********************************************************************
            // eine LP anlegen und alles Mögliche initialisieren und danach ausgeben
            // *********************************************************************

            LP OBJ_LP=new LP("lustig","Dieter Hallervorden","Didis Dussel-Disco",1980);
            
            OBJ_LP.song_aufnehmen("Punker Maria"                , 190);
            OBJ_LP.song_aufnehmen("Das ist Pop"                 ,  22);
            OBJ_LP.song_aufnehmen("So bist du"                  , 235);
            OBJ_LP.song_aufnehmen("Wehrsold-Zahlung"            ,  30);
            OBJ_LP.song_aufnehmen("Leally Good Feeling"         , 185);
            OBJ_LP.song_aufnehmen("Die schwarze Katze"          ,  47);
            OBJ_LP.song_aufnehmen("Ich bin doch kein Hahn"      , 193);
            OBJ_LP.song_aufnehmen("Didi forever"                , 201);
            OBJ_LP.song_aufnehmen("Mausi"                       , 190);
            OBJ_LP.song_aufnehmen("Beim Arzt"                   ,  18);
            OBJ_LP.song_aufnehmen("Im Fußballstadion"           ,  46);
            OBJ_LP.song_aufnehmen("Mein kleines Mädchen-ABC"    , 236);
            OBJ_LP.song_aufnehmen("Das Examen"                  ,  48);
            OBJ_LP.song_aufnehmen("Total bekloppt"              , 182);
            OBJ_LP.song_aufnehmen("Nun ratet mal"               ,  56);
            OBJ_LP.song_aufnehmen("Ach, spielen Sie doch mal...", 136);
            OBJ_LP.song_aufnehmen("Haste schon gehört?"         ,  58);
            OBJ_LP.song_aufnehmen("Wieder alles im Eimer"       , 195);
            
            // Ausgabe der Daten zum Tonträger:

            Console.WriteLine ("************************************************************************\n"                                        );
            Console.WriteLine ("Bein Tonträger handelt es sich um folenden Typ: " + OBJ_LP.GetType().Name.ToString() + " mit folgenden Details:\n");

            OBJ_LP.Drucken(); // sämtliche Infos vom Objekt ausgeben (Daten, Tracklist, Gesamtspieldauer, Durchschnittssongdauer)

            Console.WriteLine(""); // Übersichtsleerzeile

            // *************************************************************************
            // eine Single anlegen und alles Mögliche initialisieren und danach ausgeben
            // *************************************************************************
            
            single OBJ_sgl=new single("Soundtrack","Madonna","Who´s That Girl", 1987);
            OBJ_sgl.song_aufnehmen ("Who´s That Girl",238);
            OBJ_sgl.song_aufnehmen ("White Heat",265);

            // Ausgabe der Daten zum Tonträger:

            Console.WriteLine ("************************************************************************\n"                                        );
            Console.WriteLine ("Bein Tonträger handelt es sich um folenden Typ: " + OBJ_sgl.GetType().Name.ToString() + " mit folgenden Details:\n");

            OBJ_sgl.Drucken(); // sämtliche Infos vom Objekt ausgeben (Daten, Tracklist, Gesamtspieldauer, Durchschnittssongdauer)
             

        }
    }
}
